/*!
 *
 * Catenaccio Client UI v1.0.0
 *
 * Copyright 2009 D.I.M.S
 * Licensed under the LGPL license.
 * 
 * Date: 2009-10-24 06:33:54 (Sat, 24 Oct 2009)
 *
 */


///////////////////////
// global variables ///
///////////////////////

mainLayer=null;
innerLayers = Array(36);
outterLayers = Array(36);

g_radius = 80;
g_space = 11;

g_centralLeft = 0;
g_centralTop = 0;

g_currentTopValue = 0;
g_collection = "";

////////////////////
// Initialize /////
/////////////////////
$(document).ready(
  function()
  {
    mainLayer= document.getElementById('catenaccioUI');
    $("#catenaccioUI").width(250).height(250);
    $("#catenaccioCont")
          .width(250)
          .height(20);
    g_centralLeft =parseFloat(mainLayer.style.width)/2;
    g_centralTop =parseFloat(mainLayer.style.height)/2;
    mainUI();
    $("#catenaccioUI > div")
          .css('font-family','arial')
          .css('font-weight','bold')
          .css('font-size','9pt');

    
    $("#buttonLeft").bind("click",function(){spinLayers(1);});
    $("#buttonRight").bind("click",function(){spinLayers(-1);});
    $("#buttonInputTopValue").bind("click",inputTopValues);

  }
);

//////////////////////
// Basic functions ///
///////////////////////

function createLayer(id,no)
{
	var tempLayer = document.createElement("div");
	tempLayer.id = id;
	tempLayer.no = no;
	tempLayer.location = 0;
	tempLayer.style.position = "absolute";

	if (no < 10)
		txt = document.createTextNode(String(no));
	else
		txt = document.createTextNode(String.fromCharCode(87 + no));

	tempLayer.appendChild(txt);
    mainLayer.appendChild(tempLayer);
    return tempLayer;
}

function setLocation(element,top,left)
{
	element.style.top = parseInt(top);
	element.style.left = parseInt(left);
}
function inputTopValues()
{
	if (g_currentTopValue < 10) 
	{
		g_collection = g_collection + "" + g_currentTopValue;
	}
	else 
	{
		g_collection = g_collection + String.fromCharCode(87 + g_currentTopValue);		
	}	  
	alert(g_collection);
}

////////////////////////////////
//shape of wheel version////////
///////////////////////////////
function mainUI()
{
	for(var i=0;i < 36;i++)
	{     
		innerLayers[i] = createLayer(i,i);
		innerLayers[i].degree = i * 10;
		arrangeLayer_wheel(innerLayers[i],g_radius,g_centralLeft,g_centralTop);
	}
	for(var i=0;i < 36;i++)
	{     
		outterLayers[i] = createLayer(i+100,i);
		outterLayers[i].degree = i * 10;
		arrangeLayer_wheel(outterLayers[i],g_radius+g_space,g_centralLeft,g_centralTop);

	}
}

function arrangeLayer_wheel(layer,radius,centralLeft,centralTop)
{
	var radian = degToRad(layer.degree);
	var layerLeft = Math.round(Math.cos(radian) * radius) + centralLeft;
	var layerTop = -Math.round(Math.sin(radian) * radius) + centralTop;
	setLocation(layer,layerTop,layerLeft);
}

pi = 3.14;
function degToRad(x){
	return ( x/(360/(2*pi)) );
}
///////////////////////////////////////
//move the shape of wheel version//////
//////////////////////////////////////

function spinLayers(x)
{
	g_currentTopValue = (g_currentTopValue + 36 - x) % 36;
  
	for(var i=0;i<36;i++)
	{
		document.getElementById(i).degree += 10 * x;
	    var tmpleft = getLayersLeft(document.getElementById(i),g_radius,g_centralLeft,g_centralTop);
		var tmptop = getLayersTop(document.getElementById(i),g_radius,g_centralLeft,g_centralTop);
	    $('#'+i).animate({"left":tmpleft,"top":tmptop},30);
	}
}

function getLayersLeft(layer,radius,centralLeft,centralTop)
{
	var radian = degToRad(layer.degree);
	var layerLeft = Math.round(Math.cos(radian) * radius) + centralLeft;
	var layerTop = -Math.round(Math.sin(radian) * radius) + centralTop;
	return layerLeft;
}

function getLayersTop(layer,radius,centralLeft,centralTop)
{
	var radian = degToRad(layer.degree);
	var layerLeft = Math.round(Math.cos(radian) * radius) + centralLeft;
	var layerTop = -Math.round(Math.sin(radian) * radius) + centralTop;
	return layerTop;
}
