/*!
 *
 * Catenaccio Client UI v1.0.0
 *
 * Copyright 2009 D.I.M.S
 * Licensed under the LGPL license.
 * 
 * Date: 2009-10-24 06:33:54 (Sat, 24 Oct 2009)
 *
 */


///////////////////////
// global variables ///
///////////////////////

mainLayer=null;
innerLayers = Array(36);
outterLayers = Array(36);

g_radius = 70;
g_spaceBetwnFR = 11;
g_spaceBetwnLayers = 15;

g_centralLeft = 0;
g_centralTop = 0;

g_currentTopValue = 0;
g_collection = "";
////////////////////
// Initialize /////
/////////////////////
$(document).ready(
	function()
	{
		mainLayer= document.getElementById('catenaccioUI');
    
	    $("#catenaccioUI")
			.width(250)
			.height(250);
	    $("#catenaccioCont")
		    .width(250)
			.height(20);
          
	g_centralLeft =parseFloat(mainLayer.style.width)/2;
    g_centralTop =parseFloat(mainLayer.style.height)/2;
    
    mainUI();
    
    $("#catenaccioUI > div")
          .css('font-family','arial')
          .css('font-weight','bold')
          .css('font-size','9pt');
          
    $("#buttonLeft").bind("click",function(){spinLayers(1);});
    $("#buttonRight").bind("click",function(){spinLayers(-1);});
    $("#buttonInputTopValue").bind("click",inputTopValues);
	}
);

//////////////////////
// Basic functions ///
///////////////////////

function createLayer(id,no)
{
	var tempLayer = document.createElement("div");
	tempLayer.id = id;
	tempLayer.no = no;
	tempLayer.location = 0;
	tempLayer.style.position = "absolute";
	if (no < 10)
		txt = document.createTextNode(String(no));
	else
	    txt = document.createTextNode(String.fromCharCode(87 + no));
	tempLayer.appendChild(txt);
	mainLayer.appendChild(tempLayer);
	return tempLayer;
}

function setLocation(element,top,left)
{
	element.style.top = parseInt(top);
	element.style.left = parseInt(left);
}

function inputTopValues()
{
	if(g_currentTopValue < 10) 
	{
		g_collection = g_collection + "" + g_currentTopValue;
	}
	else 
	{
		g_collection = g_collection + String.fromCharCode(87 + g_currentTopValue);		
	}	  
	alert(g_collection);
}

////////////////////////////////
//shape of wheel version///////
///////////////////////////////
function mainUI()
{
	var tmp =  createLayer('test',0);
  setLocation(tmp,g_centralTop,g_centralLeft);
  
  //create inner layers
  for(var i=0;i < 36;i++)
  {     
    innerLayers[i] = createLayer(i,i);
    arrangeLayer_rectangle(innerLayers[i],g_radius,g_centralLeft,g_centralTop);
  }
  //create outter layers
  for(var i=0;i < 36;i++)
  {     
    outterLayers[i] = createLayer(i+100,i);
    arrangeLayer_rectangle(outterLayers[i],g_radius+g_spaceBetwnFR,g_centralLeft,g_centralTop);
  }
}

function arrangeLayer_rectangle(layer,radius,centralLeft,centralTop)
{

  var direction = parseInt(layer.no / 9) + 1;
  var centerPointInLine = 5 + (9 * (direction - 1)) - 1;
  var layerTop = 0;
  var layerLeft = 0;
  switch(direction)
  {
    case 1:
    case 3:
      layerTop = centralTop + (radius * (direction - 2));
      layerLeft = centralLeft + -1 *(direction - 2) * (layer.no - centerPointInLine) * g_spaceBetwnLayers;
      break;
    case 2:
    case 4:
      layerLeft = centralLeft - (radius * (direction - 3));
      layerTop = centralTop + -1 *(direction - 3) * (layer.no - centerPointInLine) * g_spaceBetwnLayers;
      break;
  }
  setLocation(layer,layerTop,layerLeft);
}
///////////////////////////////////////
//move the shape of wheel version///////
//////////////////////////////
function spinLayers(x)
{
	g_currentTopValue = (g_currentTopValue + 36 - x) % 36;
  
	for(var i=0;i<36;i++)
	{
		var nextLayers = document.getElementById((i + 36 - x) % 36);
	    var tmpleft = nextLayers.style.left;
	    var tmptop = nextLayers.style.top;
		$('#'+i).animate({"left":tmpleft,"top":tmptop},30);
	}
}
