/*!
 *
 * Catenaccio Mobile Reference Maker v1.0.0
 *
 * Copyright 2009 D.I.M.S
 * Licensed under the LGPL license.
 * 
 * Date: 2009-10-24 06:33:54 (Sat, 24 Oct 2009)
 *
 */

	var innerlayers = Array(36);
	/*
		structure of innerlayers
		1. id
		2. no
		3. degree
	*/

	
	var g_centerLeft=50,g_centerTop=50;

	var g_gap=4;
	var g_term = 20;

	var outerlayers = Array(36);
	var pi = Math.PI;
	var g_currenttop = 0;
	var remainder;
	var pivots = Array(seed.length);


	//function for converting degree to radian
	function degToRad(x){
	 	return ( x/(360/(2*pi)) );
	}			


	function generatePivots() {
		var hour = new Date();
		var hashtotal = 0;
		var pivotarray = Array(8);
		var txt = "";

		hashhour = SHA256("" + hour.getHours());
		hashseed = SHA256(seed);
		remainder = Array(seed.length);		

		alert(hashseed);

		for (var i = 0; i < 8; i++)
		{
			pivotarray[i] = parseInt("0x" + hashseed.substring(64 - 8 * (i + 1), 64 - 8 * i));
		}
		

		for (var i = 0; i < seed.length	; i++)
		{

			remainder[i] = pivotarray[i % 8] % 36;
			pivotarray[i % 8] = parseInt(pivotarray[i % 8] / 36);			
			txt = txt + "" + (i + 1) + " : " + remainder[i] + "<br>";
		}

		var temp = document.getElementById("context");
		temp.innerHTML += txt;
	}

	function showPivots()
	{
		var check = Array(seed.length);
		for (var i = 0; i < 36; i++)
			check[i] = 0;

		for (var i = 0; i < seed.length; i++)
		{
			var current = remainder[i];			
			var temp = document.getElementById("innerlayer" + remainder[i]);
			var newLeft = parseInt(temp.style.left);
			var newTop = parseInt(temp.style.top);
			var gap = 30;

			check[current]++;

			pivots[i] = document.createElement("div");
			pivots[i].id = "pivot" + i;
			pivots[i].no = i;
			pivots[i].location = 0;
			txt = document.createTextNode(i + 1);
			pivots[i].appendChild(txt);

			switch(parseInt(current / 9))
			{
			case 0:
				newTop -= (gap * check[current]);
				break;
			case 1:
				newLeft += (gap * check[current]);
				break;
			case 2:
				newTop += (gap * check[current]);
				break;
			case 3:
				newLeft -= (gap * check[current]);
				break;
			}

			pivots[i].style.left = newLeft + "px";
			pivots[i].style.top = newTop + "px";

			document.body.appendChild(pivots[i]);			
		}
	}

	//function for calculating location of the layer
	function setLocation(x, element, gap) {

		var newLeft = parseInt(element.style.left);
		var newTop = parseInt(element.style.top);

		if (element.location % 90 == 0)
		{
			switch (element.location / 90)
			{
			case 0: 
				if (x == 1)
					newLeft += gap;
				else
					newTop += gap;
				break;
			case 1:
				if (x == 1)
					newTop += gap;
				else
					newLeft -= gap;
				break;
			case 2:
				if (x == 1)
					newLeft -= gap;
				else
					newTop -= gap;
				break;
			case 3:
				if (x == 1)
					newTop -= gap;
				else
					newLeft += gap;
				break;			
			}
		}
		else
		{
		switch(parseInt(element.location / 90)) {
		case 0:
			newLeft += x * gap;
			break;
		case 1:
			newTop += x * gap;
			break;
		case 2:
			newLeft -= x * gap;
			break;
		case 3:
			newTop -= x * gap;
			break;
		}
		}
		

		element.location = (element.location + 2 * x + 360) % 360;
		
		element.style.left = newLeft + "px";
		element.style.top = newTop + "px";
	}

	
	//function for initializing
	function initialize() {
		for (var i = 0; i < 36; i++) {
		//	createInnerlayers(i);
		//	createOuterlayers(i);
		}

	}

	//function for creating an inner layer
	function createInnerlayers(x) {
		innerlayers[x] = document.createElement("div");
		innerlayers[x].id = "innerlayer" + x;
		innerlayers[x].no = x;
		innerlayers[x].location = 0;
		if (x < 10)
			txt = document.createTextNode(x);
		else
			txt = document.createTextNode(String.fromCharCode(87 + x));


		innerlayers[x].appendChild(txt);
		innerlayers[x].style.left = g_centerLeft + "px";

		innerlayers[x].style.top = g_centerTop + "px";

		for (var i = 1; i <= x * 5; i++)
		{
			setLocation(1, innerlayers[x], g_gap);
		}

		document.body.appendChild(innerlayers[x]);
	}


	//function for creating an outer layer
	function createOuterlayers(x) {
		outerlayers[x] = document.createElement("div");
		outerlayers[x].id = "outerlayer" + x;
		outerlayers[x].no = x;

		txt = document.createTextNode(x);

		outerlayers[x].appendChild(txt);

		document.body.appendChild(outerlayers[x]);

		temp = document.getElementById("innerlayer" + x);

		var tempLeft = parseInt(temp.style.left);
		var tempTop = parseInt(temp.style.top);

		switch(parseInt(x / 9)) {
			case 0:
				tempTop -= g_term;
				break;
			case 1:
				tempLeft += g_term;
				break;
			case 2:
				tempTop += g_term;
				break;
			case 3:
				tempLeft -= g_term;
				break;
		}

		outerlayers[x].style.top = tempTop + "px";
		outerlayers[x].style.left = tempLeft + "px";

	}
			
	//function for spinning layers

	var g_checkspin = false;
	var g_spintimer = null;

	
	function setSpintimer(x){
		if (g_checkspin == false) {
		    g_currenttop = (g_currenttop - x + 36) % 36;
			g_checkspin = true;
		    g_spintimer = window.setInterval('spinLayers(' + x + ')', 50);
	   	}
	}
	
	//function for
	var g_spincounter = 0;

	function spinLayers(x) {
		if (g_spincounter == 5) {
			window.clearInterval(g_spintimer);
			g_spincounter = 0;
			g_checkspin = false;
		}
		else {

			g_spincounter++;
			for (var i = 0; i < 36; i++) {
				element = document.getElementById("innerlayer" + i);
				setLocation(x, element, g_gap);
			}

		}
	}


	//function for attaching top

	
	var g_collection = "";
	function attachTop() {   
		if (g_currenttop < 10) {
			g_collection = g_collection + "" + g_currenttop;
		}
		else {
			g_collection = g_collection + String.fromCharCode(87 + g_currenttop);		
		}	  

		alert(g_collection);
	}
	
	//function for window.onload
	function addLoadEvent(func) {

		var oldonload = window.onload;
  		if (typeof window.onload != 'function') {
    			window.onload = func
  		} else {
    			window.onload = function() {
      			if (oldonload) {
       				oldonload();
      				}
      			func();
    			}
		}
	}
	addLoadEvent(initialize);
