#!/usr/bin/env python
#
# Catenaccio Server Script v1.0.0
# 
# Copyright 2009 D.I.M.S
# Licensed under the LGPL license.
# 
# Date:2009-10-24 06:18:21 (Sat, 24 Oct 2009)
#

#
# Catenaccio class
#

#
# This module use web.py(related site : http://www.webpy.org). It can be replaced by another web modules.
#
# RULES OF EDITING CODES
#
# 'm_' means a member variable
# 'r_' means a requested variable
# a name of the variables should be lower-case letters
# a name of the methods should be lower-case letters except first character of objective(this should be a upper-case letter)
# 'db.query' sentence should be wrapped 'try and except'
#

import web 
import hashlib  
import time
import urllib

class catenaccio:
    
# variables to use
    m_db = None
    m_username = None
    m_topvalues = None



# reponse to request. This is main method
    def GET(self):
        # read variables
        values = web.input()  
        if(values.r_username != None and values.r_tops != None):
            self.m_username = values.r_username
            self.m_topvalues = str(values.r_tops)
        else:
            return self.outputResult('ERROR_REQUEST')        # an exit
        
        # connect database
        self.loadDatabase()
        
        # check count of trying login
        result = self.checkCountAttempt()
        if(result == 'error'):
            return self.outputResult('ERROR_CONNECT_ATTEMPT')        # an exit
        else:
            if(result.count_attempt >= 5):
                return self.outputResult('ERROR_COUNT_ATTEMPT',result.count_attempt)   # an exit

        # encrypt r_tops(== self.m_topvalues) with reference points
        encryptedtops = self.encryptTops(self.m_topvalues)
        
        # load encrypted password
        encryptedpw = self.loadEncryptedpw()
	encryptedpw = str(encryptedpw)[18:82]

        # compare encryptedtops and encryptedpw
        if(encryptedtops == encryptedpw):
            pass
        else:
            return self.outputResult('INCORRECT')

        return self.outputResult('CORRECT')

#    
# Making result values with XML (This method is fully implemented)
#
# errorflag - sort of error messages
# infor - soft of additional information. For example, count_attempt
# 
# ERROR MESSAGES (On working... sorry about it, we left this for you to develop)
# 
# ERROR_REQUEST
# ERROR_CONNECT_ATTEMPT
# ERROR_COUNT_ATTEMPT
# ERROR_NOT_CORRESPONDENCE
# OK_CORRECT
#


    def outputResult(self,errorflag,infor=0):
	if (errorflag == 'CORRECT'):
	    #page = urllib.urlopen("http://catelogin.cafe24.com/RedTie/suc.html")
	    option = "http://catelogin.cafe24.com/RedTie/suc.html"
	else:
	    #page = urllib.urlopen("http://catelogin.cafe24.com/RedTie/fail.html")
            option = "http://catelogin.cafe24.com/RedTie/fail.html"
        page = '''<html><body onload="javascript:window.opener.parent.location.href='%s';window.close();"></body></html>''' % (option)

	return page

    
# Loading the database which has information of identifying users
    def loadDatabase(self):
        self.db = web.database(dbn='sqlite',db='./authDB.db')


# Checking the number of attempts that a user did 
    def checkCountAttempt(self):
        try:
            output = self.db.query('select count_attempt from auth where id ="'+ self.m_username+'"')
        except:
            return 'error'
        else:
            result = list(output)
	    if(len(result) == 0):
		return 'error'
	    else:
            	return result[0]
        
#      
    def loadEncryptedpw(self):
        count = self.db.query('select pw from auth where id ="'+ self.m_username+'"')
        result = list(count)
        return result[0]

    
#
    def encryptTops(self,tops):
        try:
            seed = self.db.query('select seed from auth where id ="'+ self.m_username+'"')
        except:
            return 'error'

        # calculating hash value to make the reference points
        # This algorithm can be replaced others better than this
        seedvalue = list(seed)

	if(len(str(seedvalue[0].seed)) != len(self.m_topvalues)):
	    return 0

        hash_seed = int(hashlib.sha256(str(seedvalue[0].seed)).hexdigest(),16)
        hash_time = int(hashlib.sha256(str(time.localtime().tm_hour)).hexdigest(),16)
	hash_seed_str = hashlib.sha256(str(seedvalue[0].seed)).hexdigest()

        hash_total = hash_seed #+ hash_time
	temp = []
	temp += self.m_topvalues
        # Changing specific 'tops' variables, 0~9. It can be helpful followed logic.

        for cnt,character in enumerate(self.m_topvalues):
            if('0' <= character <= '9'):
                temp[cnt] = ord(character) + 75
	    else:
		temp[cnt] = ord(character)
	# Calculating
        remainder = []
	pivotarray = []
        length = len(str(seedvalue[0].seed))
        decrypted_tops = []
	decrypted_tops_str = ""

	for cnt in range(0, 8):
	    start = 64 - 8 * (cnt + 1)
	    end = 64 - 8 * cnt
	    tmp = hash_seed_str[start:end]
	    pivotarray.append(tmp)

	for cnt in range(length):
	    tmp = int(pivotarray[cnt % 8], 16) % 36
	    remainder.append(tmp)
	    tmp = hex(int(pivotarray[cnt % 8], 16) / 36)
	    pivotarray[cnt % 8] = tmp
            decrypted_tops += [temp[cnt] + remainder[cnt]]	
	    if(decrypted_tops[cnt] > 132):
		decrypted_tops[cnt] = temp[cnt] - (36 - remainder[cnt])

	# Restoring 
	temp = []
        for cnt,character in enumerate(decrypted_tops):
            if(ord('z')  < character):
                temp +=  chr(character - 75)
	    else:
		temp +=  chr(character)
	for item in temp:
		decrypted_tops_str += str(item)

        return hashlib.sha256(decrypted_tops_str).hexdigest()
    

#
# web.py - urls
#

urls = (
    '/','catenaccio'
    )
#
# web.py - main
#

app = web.application(urls,globals())

if __name__ == '__main__':
    app.run()
    
